package fi.em.formPlugin;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.exception.KDBizException;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.operate.botp.Draw;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.ArrayList;
import java.util.List;

public class TravelChargePrepaidLoanEditPlugin extends AbstractListPlugin implements Plugin {
    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        if (args.getSource() instanceof Draw) {
            Draw draw = (Draw) args.getSource();
            if (draw.getOperateKey().equals("draw-clyf")) {
                //诉讼核销
                Object values = this.getModel().getValue("applier");//获取当前单据报销人
                DynamicObject dynamicObjects = (DynamicObject) values;
                if (dynamicObjects == null) {
                    throw new KDBizException("报销人为空！");
                }
                DynamicObjectCollection nckdEntryentity1 = this.getModel().getEntryEntity("nckd_clearloanentry");
                JSONArray jSONArray = new JSONArray();
                for(int i=0;i<nckdEntryentity1.size();i++){
                    JSONObject jsonObject = new JSONObject();
                    DynamicObject dynamicObject1 = nckdEntryentity1.get(i);
                    String nckdTextfield7 = dynamicObject1.getString("nckd_bigintfield2");
                    jsonObject.put("id",nckdTextfield7);
                    jSONArray.add(jsonObject);
                }
                String userid = dynamicObjects.getString("id");//当前单据报销人id
                draw.getOption().setVariableValue("userid", userid);
                draw.getOption().setVariableValue("orgnumber", userid);
                draw.getOption().setVariableValue("JSONArray", jSONArray.toString());
                draw.getOption().setVariableValue("type", "draw-clyf");
            }
        }
    }

}
