package fi.fa.formPlugin;

import com.alibaba.druid.util.StringUtils;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.field.DateEdit;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.fi.fa.common.util.DateUtil;

import java.util.Date;
import java.util.EventObject;

public class LeaseContractFormPlugin extends AbstractFormPlugin {
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        String fieldKey = e.getProperty().getName();
        if (StringUtils.equals(fieldKey, "leasestartdate")) {
            this.setFreeLeaseStartDateRange();
        }
    }

    @Override
    public void afterBindData(EventObject e) {
        this.setFreeLeaseStartDateRange();
    }

    private void setFreeLeaseStartDateRange() {
        Date leaseStartDate = (Date)this.getModel().getValue("leasestartdate");
        if (leaseStartDate != null) {
            DateEdit freeLeaseStartDateEdit = (DateEdit)this.getView().getControl("freeleasestartdate");
            freeLeaseStartDateEdit.setMaxDate(DateUtil.addDay(leaseStartDate, 0));
            Date freeLeaseStartDate = (Date)this.getModel().getValue("freeleasestartdate");
        }
    }
}
