package fi.fa.opplugin;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.entity.ExtendedDataEntity;
import kd.bos.entity.validate.AbstractValidator;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.fi.fa.business.validator.lease.LeaseChangeBillValidator;

public class FaLeaseChangeBillExSubmitValidator extends AbstractValidator {
    private DynamicObject aftContract = null;

    public FaLeaseChangeBillExSubmitValidator() {
    }

    public FaLeaseChangeBillExSubmitValidator buildAftContract(DynamicObject aftContract) {
        this.aftContract = aftContract;
        return this;
    }

    public void validate() {
        ExtendedDataEntity[] dataEntities = this.dataEntities;
        List<Long> oriContractIds = new ArrayList(dataEntities.length);
        ExtendedDataEntity[] var3 = dataEntities;
        int var4 = dataEntities.length;

        for(int var5 = 0; var5 < var4; ++var5) {
            ExtendedDataEntity dataEntity = var3[var5];
            DynamicObject bill = dataEntity.getDataEntity();
            DynamicObject orileaseContract = bill.getDynamicObject("leasecontract");
            oriContractIds.add(orileaseContract.getLong("id"));
        }

        DynamicObject[] changeBakContractArr = BusinessDataServiceHelper.load(oriContractIds.toArray(new Long[0]), EntityMetadataCache.getDataEntityType("fa_lease_contract"));
        Map<Long, DynamicObject> id2OriLeaseContractMap = (Map)Arrays.stream(changeBakContractArr).collect(Collectors.toMap((v) -> {
            return v.getLong("id");
        }, (v) -> {
            return v;
        }));
        ExtendedDataEntity[] var17 = dataEntities;
        int var18 = dataEntities.length;

        for(int var19 = 0; var19 < var18; ++var19) {
            ExtendedDataEntity dataEntity = var17[var19];
            DynamicObject bill = dataEntity.getDataEntity();
            DynamicObject oriLeaseContractId = bill.getDynamicObject("leasecontract");
            DynamicObject oriLeaseContract = (DynamicObject)id2OriLeaseContractMap.get(oriLeaseContractId.getLong("id"));
            List<String> errorInfoList = LeaseChangeBillExValidator.validate4Submit(bill, this.aftContract, oriLeaseContract);
            Iterator var13 = errorInfoList.iterator();

            while(var13.hasNext()) {
                String errorInfo = (String)var13.next();
                this.addErrorMessage(dataEntity, errorInfo);
            }
        }

    }
}
